#!/usr/bin/perl

use strict;
use warnings;

use Simusol::Swig_ExprTk;
use Simusol::Swig_GSL;


  Simusol::Swig_ExprTk::composite(1,0,1);
  Simusol::Swig_ExprTk::add_var("UNO",0);
  Simusol::Swig_ExprTk::add_equation("9-UNO*UNO",0);
 
  my $success=0;
  my $itera=0;
	 
  my   $rty= Simusol::Swig_GSL::comienza(1, 1,0,0,0,0, 0,1,1,
				      Simusol::Swig_GSL::create_double_array([2]),
                                      Simusol::Swig_GSL::create_int_array([0]), 
                                      Simusol::Swig_GSL::create_string_array(["UNO"]),
                                      Simusol::Swig_GSL::create_int_array([0]), 
                                      Simusol::Swig_GSL::create_int_array([0]), 
                                      Simusol::Swig_GSL::create_int_array([]),    #numgslpar
                                      Simusol::Swig_GSL::create_double_matrix([[]]), #l=
			              Simusol::Swig_GSL::create_int_array([0]), #ltra
                                      Simusol::Swig_GSL::create_int_array([0]),
                                      Simusol::Swig_GSL::create_int_array([0]),   # completo sin recortar, se necesita para pasar variables completas a exprtk
                                      Simusol::Swig_GSL::create_int_matrix([[1]]),
				      Simusol::Swig_GSL::create_int_array([]), #L0
				      Simusol::Swig_GSL::create_int_matrix([[-1],[-2]]),
                                      1,
                                      \$itera,
                                      \$success				  
                                      );

	   

  
  print "ITERA: $itera EXITO: $success\n";

  my $final=Simusol::Swig_GSL::double_get_final ($rty,0);

  print "ECUACION: 9-UNO*UNO ; VARIABLE: UNO;   SOLUCION: $final\n";  # OJO VER ORDENTOTAL EN GSL.PM numlin 262
        
