
/////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_multiroots.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_multifit_nlin.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
//#define GSL_SQRT_DBL_EPSILON   1.4901161193847656e-08


#include "simusol_gsl.h"
//#include "../../Exprtk/src/simusol_exprtk.h"
double evaluate(int);
void set_var(int,double);

double *final;

struct rparams
  {
    //double a;
    //double b;
    gsl_vector *parameters;
    int NV;
    int NE;
    int NFM;
    int NCM;
    int CER;
    int NVF; 
    double *matrizred;
    int *lrtra;
    int *orieqreten;
     int *ordentot;
    int *indep;
    int *dp;
    int NVM; 
  };
int root_f (const gsl_vector * x, void *params, gsl_vector * f)
{
  //double a = ((struct rparams *) params)->a;
  //double b = ((struct rparams *) params)->b;
  gsl_vector *ps = ((struct rparams *) params)->parameters;
  int NV=((struct rparams *) params)->NV;
  int NE=((struct rparams *) params)->NE;
  int NP=NV-NE;
  int NFM=((struct rparams *) params)->NFM;
  int NCM=((struct rparams *) params)->NCM;
  int CER=((struct rparams *) params)->CER;
  int NVF=((struct rparams *) params)->NVF;
  int *lrtra=((struct rparams *) params)->lrtra;
  int *orieqreten=((struct rparams *) params)->orieqreten;
  double *matrizred=((struct rparams *) params)->matrizred;
  int *ordentot=((struct rparams *) params)->ordentot;
  int *indep=((struct rparams *) params)->indep;
  int *dp=((struct rparams *) params)->dp;
  int NVM=((struct rparams *) params)->NVM;
   
  //  const double x0 =;
  //const double x1 = gsl_vector_get (x, 1);
  //printf("ADD ECUA NV %d NP %d NFM %d NCM %d CER %d\n",NV,NP,NFM,NCM,CER);



   //// mejor usar tres vectores uno que traduza de las inmutables a los parametros, otra de los i a las var, y otro de las i a las cero
   double ttt[NV];//={0}; falla en gcc 4.8 no en 4.9

 for (int i=0; i<NV; i++){//entiendo puede ir NCM y no NV  NCM<NV?
      ttt[i]=0;
      }
   
 for (int i=0; i<NCM; i++){    //existen dos lugares para corregir, uno el orden de los valores de las variables que vienen de datos/inicio
                               //otro como asigna con set var  a las variables que son de exprtk    
   //int j=ordentot[i];
   int z=lrtra[i];   //////////////////////////////////////
     if (z<(NV-NP)){
       ttt[i]=gsl_vector_get (x, z);
     }else{
       ttt[i]=gsl_vector_get (ps, z-NV+NP);
     }
    
     printf("LRTRA/NCM: %i/%i, %i: %3.1f\n",i,NCM, lrtra[i],ttt[i]);
    
    };
 //printf("\n");

 //   printf("ADD ECUA V");
 // for (int i=0; i<NCM; i++){
 //   printf(" %3.1f ",ttt[i]);
 // }
 //printf("\n");


   // core dump if NFM=0   double res[NFM]={0};

 double res[NFM];

 for (int i=0; i<NFM; i++){
   //printf ("ADD ECUA M ");
   res[i]=0;
   for (int j=0; j<NCM; j++){     
     res[i]+=matrizred[i*NCM+j]*ttt[j];
     printf("%2.0f ",matrizred[i*NCM+j]);
     
     };
   printf("\n");
   res[i]+=indep[i];
 };


 /*   for (int i=0; i<5; i++){
    set_var(i, 0.); ///////////////////////////////////////////////
    //
    };
 */
 
 
 //printf("XXXX %i\n",NFM);
 
  for (int i=0; i<(NV-NP); i++){
    //printf("VARIAB: %i, %f\n",i, gsl_vector_get (x, i));
    int j=ordentot[i];
    set_var(j, gsl_vector_get (x, i)); ///////////////////////////////////////////////
    //
    };
     // set_var(1,x1);

  //printf("PARAMS %f %f \n",gsl_vector_get (ps, 0),    gsl_vector_get (ps, 1));
  
  // set_var(3,b);
for (int i=NV-NP; i<NV; i++){
  //printf("PARAM %d GSL %d %f \n", i,i-(NV-NP),gsl_vector_get (ps, i-(NV-NP)));
  int j=ordentot[i];  
  set_var(j,gsl_vector_get (ps, i-(NV-NP)));/////////////////////////////////////////////
  }

// ordentot ahora no llega ahi VERRRRRRRRRRR
 for (int i=NV; i<NV+NVF; i++){   // hace falta o no poner en 0 las variables extra que no se usan?
  //printf("PARAM %d GSL %d %f \n", i,i-(NV-NP),gsl_vector_get (ps, i-(NV-NP)));
   int j=ordentot[i];  
   set_var(j,0.); //////////////////////////////////////////////////////
  }


// for (int i=0; i<NE; i++){
//      double yyy=evaluate(i);
//     // gsl_vector_set (f, i, yyy);
//      printf("ECUA: %i, %f\n",i, yyy);
//   
   //
//    };


   //const double y0=;
   //const double y1=;
   
   //const double y00 = a * (1 - x0);
   //const double y11 = b * (x1 - x0 * x0);
   //printf ("DIFERENCIAS: %f C %f  ; %f C %f\n", y0,y00, y1,y11);
   //printf("NE %d\n",NE);

 for (int i=0; i<NFM; i++){
   gsl_vector_set (f, i, res[i]);
   //printf("ADD ECUA MATRIZRED: %i, %f\n",i, res[i]);
    //
    };

 //  for (int i=NFM; i<NE; i++){
 int j=0;
 for (int i=0; i<NE-NFM; i++){    
      double yyy=evaluate(orieqreten[j++]);
      gsl_vector_set (f, i+NFM, yyy);
      //printf("ADD ECUA r: %i, %f\n",i+NFM, yyy);
   
    //
    };



   
   // gsl_vector_set (f, 1, evaluate(1));

   
  
  return GSL_SUCCESS;
}
/////////////////////////////////////////////////////////////////////////
int print_state_ini  (size_t iter, gsl_multiroot_fsolver * s,const char *vars[], int numgslvar[], int numgslpar[], int NE,int NP,const gsl_vector* param, int ordentot[])
{
  printf ("RESRES iter = %3u;",iter);
 for (int i=0;i<NE;i++){
     printf ("   %s", vars[numgslvar[ordentot[i]]]);
        }

   for (int i=0;i<NP;i++){
     printf ("   %s", vars[numgslpar[ordentot[i]]]);
   }
   printf("\n");
}


int
print_state (size_t iter, gsl_multiroot_fsolver * s,const char *vars[], int numgslvar[], int numgslpar[], int NE,int NP,const gsl_vector* param, int ordentot[])
{

    printf ("RESRES ITERA = %3u;",iter);
    for (int i=0;i<NE;i++){   //NV -NP
     //printf (" %s:% .3f", vars[numgslvar[i]], gsl_vector_get (s->x, i));
     printf (" % .3f",             gsl_vector_get (s->x, i));
   }

   for (int i=0;i<NP;i++){
     printf (" % .3f",gsl_vector_get (param,i));
     //  printf (" %s:% .3f", vars[numgslpar[i]], gsl_vector_get (param,i));
   }
   /* printf("; f(x) = ");
  for (int i=0;i<NE;i++){
    printf (" % .3e",gsl_vector_get (s->f, i));
    }*/
  printf("\n");
  
}


///////////////////////////////////////////////////////////////
double get_det(gsl_matrix * A) {
  int sign=0; double det=0.0; int row_sq = A->size1;
  gsl_permutation * p = gsl_permutation_calloc(row_sq);
  gsl_matrix * tmp_ptr = gsl_matrix_calloc(row_sq, row_sq);
  int * signum = &sign;
  gsl_matrix_memcpy(tmp_ptr, A);
  gsl_linalg_LU_decomp(tmp_ptr, p, signum);
  det = gsl_linalg_LU_det(tmp_ptr, *signum);
  gsl_permutation_free(p);
  gsl_matrix_free(tmp_ptr);
  return det;
}
///////////////////////////////////////////////////////////////////////////////
void   printdata(int NV, int NE,const char *vars[], int espar[],int numvar[],const gsl_vector* param, const gsl_vector* x, const gsl_vector * fc, gsl_matrix * J, gsl_matrix * JD, int ordentot[]){




  /* for (int j=0; j<NV; j++){ 
   printf("esparB %d %d\n",j,espar[j]);
   }*/
  
  printf("\nRES ************************************NV %d NE %d ****\n",NV,NE);
   printf("RES         vars: ");
   for (int j=0; j<NV; j++){  
     printf("%7s ",vars[ordentot[j]]);
   }
   printf ("\n");
   printf("RES        espar: ");
   for (int j=0; j<NV; j++){  
     printf("%7i ",espar[j]);
   }
   printf ("\n");
    printf("RES  valor/valor: ");
   for (int j=0; j<NV; j++){
      if (espar[j]){ 
	printf("%7.2e ",gsl_vector_get(param,numvar[j]));
    }else{
	printf("%7.2e ",gsl_vector_get(x,numvar[j]));
    }
           
   }
   printf ("\n");
   for (int i=0; i<NE; i++){
     printf("RES %3i %9.2e: ",i,gsl_vector_get (fc,i));
      for (int j=0; j<NV; j++){
	printf("%7.e ",gsl_matrix_get(J,i,j));
        }
        printf("\n");
      }
      printf("\n");

      /* printf("RES         vars: ");
   int k=0;
   for (int j=0; j<NV; j++){ 
     if (espar[j]==0){
       printf("%7s ",vars[k]);
	k++;
     }else{
       k++;
     }  
       
     }
       printf("\n");*/
       /*   for (int i=0; i<NE; i++){
     printf("RES %3i %9.2e: ",i,gsl_vector_get (fc,i));
      for (int j=0; j<NE; j++){
	printf("%7.e ",gsl_matrix_get(JD,i,j));
        }
        printf("\n");
      }
      printf("\n");*/
      printf("RES          det: %12.5e\n", get_det(JD));
  printf("****************************************\n");
}



// determinante total lento, previo matriz, cambiando poco pasar ciclo NE de afuera a solo asignacion de resultados, se recalcula todo al vicio en cada ecuacion
void   calcdatav(int NV, int NE, int espar[],int numvar[], gsl_vector* param, gsl_vector* x, gsl_vector * fc, gsl_matrix * J, gsl_matrix * JD,struct rparams p,int NFM,int NCM, int NVF, double *matrizred, int lrtra[],int orieqreten[],int ordentot[]){
  for (int j=0; j<NV; j++){  //esto es al vicio, ya valen eso.
      if (espar[j]){
      	double valor=gsl_vector_get (param,numvar[j]);
	gsl_vector_set (param,numvar[j],valor);
      }else{
        double valor=gsl_vector_get (x,numvar[j]);
	gsl_vector_set (x,numvar[j],valor);
        }
       }
 
   double DELTA=0.01;
   
   gsl_vector *fd = gsl_vector_alloc (NE);
   root_f ( x, &p,fc);
   /*  printf("PPPUNTO x %d, vale %f \n",18,gsl_vector_get (x,18));
    printf("PPPUNTO x %d, vale %f \n",3,gsl_vector_get (x,3));
    printf("PPPUNTO es ecua %d, vale %f \n",20,gsl_vector_get (fc,20));
   */  
   //for (int i=0; i<NE; i++){
   //printf("PUNTO es ecua %d, vale %f \n",i,gsl_vector_get (fc,i));
     // }
   
   printf("****************************************\n");
   for (int i=0; i<NE; i++){
     //
      double valorc=gsl_vector_get (fc,i);
      //for (int j=0; j<NV-NE; j++){
      for (int j=0; j<NV; j++){
	//	printf("MATRIZ %d %d ",i,j);
    if (espar[j]){
      	double valor=gsl_vector_get (param,numvar[j]);
	gsl_vector_set (param,numvar[j],valor+DELTA);
	root_f (x, &p,fd);
	gsl_vector_set (param,numvar[j],valor);
	//printf("gsl par %d, es var %d, vale %f \n",numvar[i],i,gsl_vector_get (param, numvar[i]));
    }else{
        double valor=gsl_vector_get (x,numvar[j]);
	gsl_vector_set (x,numvar[j],valor+DELTA);
	root_f (x, &p,fd);
	
	//printf("gsl var %d, es var %d, vale %f \n",numvar[i],i,gsl_vector_get (s->x, numvar[i]));
	/*	if ((numvar[j]==18 or numvar[j]==3) and i==20){
	    printf("PPPUNTO x %d, vale %f \n",18,gsl_vector_get (x,18));
    printf("PPPUNTO x %d, vale %f \n",3,gsl_vector_get (x,3));
    printf("PPPUNTO es ecua %d, vale %f \n",20,gsl_vector_get (fd,20));
    double yyy=evaluate(20);
     printf("PPPUNTO  vale %f \n",yyy);
	}*/
	gsl_vector_set (x,numvar[j],valor);
	gsl_matrix_set(JD,i,numvar[j],(gsl_vector_get (fd,i)-valorc)/DELTA);	
    }  
	gsl_matrix_set(J,i,j,(gsl_vector_get (fd,i)-valorc)/DELTA);
	//printf("%f:%f:%f- %f ",gsl_vector_get (fd,i),valorc, DELTA,(gsl_vector_get (fd,i)-valorc)/DELTA);
       }
     
   }

    }

/////////////////////////////////////////////////////////////////////////////////////////
void   calcdata(int NV, int NE, int espar[],int numvar[], gsl_vector* param, gsl_vector* x, gsl_vector * fc, gsl_matrix * J, gsl_matrix * JD,struct rparams p,int NFM,int NCM, int NVF, double *matrizred, int lrtra[],int orieqreten[],int ordentot[], int *dp, int NVM){

  /*for (int j=0; j<NV; j++){  //esto es al vicio, ya valen eso.
      if (espar[j]){
      	double valor=gsl_vector_get (param,numvar[j]);
	gsl_vector_set (param,numvar[j],valor);
      }else{
        double valor=gsl_vector_get (x,numvar[j]);
	gsl_vector_set (x,numvar[j],valor);
        }
      }
  */
   double DELTA=0.01;
   

   root_f (x, &p,fc);

   gsl_vector *fd = gsl_vector_alloc (NE);

   printf("****************************************\n");

   /* for (int i=NV; i<NV+NVF; i++){
       set_var(ordentot[i],0); 
       }
   */
   // quizas existan variables que no sea necesarias meter cambiadas.
   for (int j=0; j<NV; j++){
   
        double valor=0;
        if (espar[j]){
	   
      	   valor=gsl_vector_get (param,numvar[j]);
  	   //gsl_vector_set (param,numvar[j],valor+DELTA);
	   //   root_f (x, &p,fd);         
           set_var(ordentot[j],valor+DELTA);	   
           int kj=0;
           for (int ki=0; ki<NE-NFM; ki++){    	
	          //gsl_vector_set (fd, ki+NFM, evaluate(orieqreten[kj++]));
	          printf("MATRIZ %d %d : %d ",orieqreten[kj],ordentot[j],dp[(orieqreten[kj])*NVM+ordentot[j]]);
        
		  int valord=dp[(orieqreten[kj])*NVM+ordentot[j]];

		  if (valord==-2){ // la matriz dp nos indica que las ecuaciones que tienen -2 no incluyen la variable  
			 printf( "xxNOCER ");
			 gsl_matrix_set(J, ki+NFM,j,0.);
			
			 //double ev=evaluate(orieqreten[kj]);
			 //double deri=(ev-gsl_vector_get (fc, ki+NFM))/DELTA;
			 //gsl_matrix_set(J, ki+NFM,j,deri);
		 }else if(valord==-1){
		        double ev=evaluate(orieqreten[kj]);
  		        double deri=(ev-gsl_vector_get (fc, ki+NFM))/DELTA;
			gsl_matrix_set(J, ki+NFM,j,deri);
		        printf( "xxNORMA ");
		  }else{
		        double deri=evaluate(valord);
			//double deri=(ev-gsl_vector_get (fc, ki+NFM))/DELTA;
			gsl_matrix_set(J, ki+NFM,j,deri);                        
			printf ("xxNOPFD  ");
		  }
		  kj++;
	          /*double ev=evaluate(orieqreten[kj++]);
		  gsl_matrix_set(J, ki+NFM,j,(ev-gsl_vector_get (fc, ki+NFM))/DELTA);
		  */
                  };
	   printf("\n");
	   //gsl_vector_set (param,numvar[j],valor);
	   // printf("gsl par %d, es var %d, vale %f \n",numvar[i],i,gsl_vector_get (param, numvar[i]));
        }else{
	  //printf("LLEGUE NO PAR %d - %f\n",j,DELTA);
           valor=gsl_vector_get (x,numvar[j]);
   	   //gsl_vector_set (x,numvar[j],valor+DELTA);
	   // root_f (x, &p,fd);
           set_var(ordentot[j],valor+DELTA);
	    
           int kj=0;
           for (int ki=0; ki<NE-NFM; ki++){
	     // printf("LLEGUE NO PAR 2 %d - %d - %d\n",ki,kj,NE-NFM);
                  //gsl_vector_set (fd, ki+NFM, evaluate(orieqreten[kj++]);
	          //double ev=evaluate(orieqreten[kj]);
		  
	          //gsl_matrix_set(J, ki+NFM,j,(ev-gsl_vector_get (fc,ki+NFM))/DELTA);
     	          //gsl_matrix_set(JD,ki+NFM,j,(ev-gsl_vector_get (fc,ki+NFM))/DELTA);


		  printf("MATRIZ %d %d : %d ",orieqreten[kj],ordentot[j],dp[(orieqreten[kj])*NVM+ordentot[j]]);        
		  int valord=dp[(orieqreten[kj])*NVM+ordentot[j]];
		  if (valord>NE){
		      printf("\nERROR: VALORD %d (contenido de dp), es mayor que NE %d, pos en dp: %d orieqreten: %d, ordentot: %d, kj: %d,j: %d,NVM: %d\n",valord,NE,(orieqreten[kj])*NVM+ordentot[j],orieqreten[kj],ordentot[j],kj,j,NVM);
                    exit(0);             
		     }
		  if (valord==-2){ // la matriz dp nos indica que las ecuaciones que tienen -2 no incluyen la variable  
			 printf( "xxNOCER ");
			 //printf("LLEGUE NO PAR 2M VALORD -2\n");
			 gsl_matrix_set(J, ki+NFM,j,0.);
			 gsl_matrix_set(JD, ki+NFM,j,0.);			
			 //double ev=evaluate(orieqreten[kj]);
			 //double deri=(ev-gsl_vector_get (fc, ki+NFM))/DELTA;
			 //gsl_matrix_set(J, ki+NFM,j,deri);
		 }else if(valord==-1){
		    //printf("LLEGUE NO PAR 2M VALORD -1\n");
		        double ev=evaluate(orieqreten[kj]);
  		        double deri=(ev-gsl_vector_get (fc, ki+NFM))/DELTA;
			gsl_matrix_set(J, ki+NFM,j,deri);
			gsl_matrix_set(JD, ki+NFM,j,deri);
		        printf( "xxNORMA ");
		 }else{
		    //  printf("LLEGUE NO PAR 2M VALORD ELSE %d\n",valord);
		        double deri=evaluate(valord);
			//	printf("LLEGUE NO PAR 2M VALORD ELSE: %f\n",deri);
			//double deri=(ev-gsl_vector_get (fc, ki+NFM))/DELTA;
			gsl_matrix_set(J, ki+NFM,j,deri);
 		        gsl_matrix_set(JD, ki+NFM,j,deri);			
			printf ("xxNOPFD  ");
		  }
		  kj++;
	          /*double ev=evaluate(orieqreten[kj++]);
		  gsl_matrix_set(J, ki+NFM,j,(ev-gsl_vector_get (fc, ki+NFM))/DELTA);
		  */
                  };
	   printf("\n");
           //printf("LLEGUE NO PAR 2FIN\n");
	   
	   //gsl_vector_set (x,numvar[j],valor);
	   //for (int i=0; i<NE; i++){                              
	   //    gsl_matrix_set(JD,i,numvar[j],(gsl_vector_get (fd,i)-gsl_vector_get (fc,i))/DELTA);
	   //    }
           }
	//printf("LLEGUE 2 %d\n",j);
        set_var(ordentot[j],valor);
        //for (int i=0; i<NE; i++){           
	//  gsl_matrix_set(J,i,j,(gsl_vector_get (fd,i)-gsl_vector_get (fc,i))/DELTA);
	//   //printf("%f:%f:%f- %f ",gsl_vector_get (fd,i),valorc, DELTA,(gsl_vector_get (fd,i)-valorc)/DELTA);
	//   }
   }


   printf("LLEGUE \n");
  
   for (int j=0; j<NV; j++){ //-NP en JD
     for (int i=0; i<NFM; i++){
         gsl_matrix_set(J,i,j,0);	 
         }
     }
   
   for (int j=0; j<NCM; j++){
     int k=lrtra[j];                         
     for (int i=0; i<NFM; i++){
         gsl_matrix_set(J,i,k,matrizred[i*NCM+j]);	 
       }
     }

  for (int j=0; j<NE; j++){ //-NP en JD
     for (int i=0; i<NFM; i++){
         gsl_matrix_set(JD,i,j,0);	 
         }
     }
   
   for (int j=0; j<NCM; j++){
     int k=lrtra[j];
      if (espar[k]==0){
     for (int i=0; i<NFM; i++){
         gsl_matrix_set(JD,i,k,matrizred[i*NCM+j]);	 
     }}
     }
 
   

    }
/////////////////////////////////////////////////////


// NOTA CER NO SE USA
double * comienza(int NV, int NE, int NP, int NFM, int NCM, int CER, int NVF, int NFIM, int NCIM, double *inicial,int espar[], const char * vars[],int numvar[], int numgslvar[],int numgslpar[], double *matrizred, int lrtra[], int orieqreten[], int ordentot[], int *intmatriz, int indep[], int *dp, int NVM, int *itera, int *success){



  // tomar vars de ExprTk !!!!, dado que ya las tiene para poder funcionar
  
   *success=1;
  printf("COMIENZA\n");
  // for (int j=0; j<NV; j++){ 
   //printf("espar %d %d\n",j,espar[j]);
  //}
  //for (int j=0; j<NV; j++){ 
   //printf("espar %d %d\n",j,espar[j]);
  //}
  final=(double *) malloc(sizeof(double)*NV);
  
  /*	
  for (int i=0; i<NV; i++){
    printf("ParESPAR %d, espar %d numvar %d\n",i,espar[i],numvar[i]);
    }

  */
  const gsl_multiroot_fsolver_type *T1;
  const gsl_multiroot_fsolver_type *T2;
  gsl_multiroot_fsolver *s;

  int status;
  size_t i;
  
  // *itera=0;
  //printf("ITERA1 %d\n",*itera);
  const size_t n = NV-NP;
  gsl_vector *param;
  if (NP){
     param = gsl_vector_alloc (NP);
    }


  gsl_vector *x = gsl_vector_alloc (n);
  
  
	
  for (int i=0; i<NP; i++){
       printf("gsl par %d, es var %d val %f, %s\n",i,numgslpar[i],inicial[numgslpar[i]],vars[ordentot[numgslpar[i]]]);//no parece bien vars[ordentot i]
       gsl_vector_set (param, i, inicial[numgslpar[i]]);
       }

  //printf("NV: %d NP: %d\n",NV,NP);
 for (int i=0; i<NV-NP; i++){
      printf("gsl var %d, es var %d val %f, %s\n",i,numgslvar[i],inicial[numgslvar[i]],vars[ordentot[numgslvar[i]]]);//no parece bien vars[ordentot i]
      gsl_vector_set (x, i, inicial[numgslvar[i]]);
       //
       }


 //exit(0);
 
 struct rparams p = {//1.0, 10.0,
   param, NV,NE,   NFM, NCM, CER, NVF,  matrizred,lrtra,orieqreten,ordentot,indep,dp,NVM};
 
 
  gsl_multiroot_function f = {&root_f, n, &p};
  T1 = gsl_multiroot_fsolver_hybrids;
  //T2 = gsl_multiroot_fsolver_dnewton;

  s = gsl_multiroot_fsolver_alloc (T1, NE);

  printf("4 NV: %d NP: %d NE: %d  n: %d \n",NV,NP,NE,n);

  
for (int i=0; i<n; i++){
      double rr=0;
      rr=gsl_vector_get (x, i);
      printf("gsl var2 %d, vale %f \n",i,rr);
    }

  printf("4.5 NV: %d NP: %d n: %d NCM: %d\n",NV,NP,n,NCM);
  gsl_multiroot_fsolver_set (s, &f, x);

  printf("5 NV: %d NP: %d n: %d\n",NV,NP,n);
   
  gsl_matrix *J = gsl_matrix_alloc (NE, NV);
  gsl_matrix *JD = gsl_matrix_alloc (NE, NE);
  gsl_vector *fc = gsl_vector_alloc (NE);

  printf("6 NV: %d NP: %d n: %d\n",NV,NP,n );
  calcdata(NV, NE, espar,numvar,param,s->x,fc,J,JD,p,NFM,NCM,NVF,matrizred,lrtra,orieqreten,ordentot,dp,NVM);
  printdata(NV, NE,vars,espar, numvar,param, s->x,fc, J, JD,ordentot);
  
  //printf("K2\n");
   
for (int i=0; i<NV; i++){
    double rr=0;
    if (espar[i]){
      rr=gsl_vector_get (param, numvar[i]);
      printf("gsl par2 %d, es var %d, vale %f, %s \n",numvar[i],i,rr,vars[ordentot[i]]);
    }else{
      rr=gsl_vector_get (s->x, numvar[i]);
      printf("gsl var2 %d, es var %d, vale %f, %s \n",numvar[i],i,rr,vars[ordentot[i]]);
    }
    final[i]=rr;
  }
//return final;

 
  
  // print_state_ini (iter, s,vars,numgslvar,numgslpar,NE,NP,param);
  do
    {
      (*itera)++;
      
      status = gsl_multiroot_fsolver_iterate (s);

      calcdata(NV, NE, espar,numvar,param,s->x,fc,J,JD,p,NFM,NCM,NVF,matrizred,lrtra,orieqreten,ordentot,dp,NVM);
      double gdet=get_det(JD);
      printf("RES          det: %12.5e\n",gdet );
      if (gdet == 0){
         printf("det cero salgo\n");
         //final[0]=-3.1415;                                                        //HORRIBLE CAMBIAR
	  *success=-1;
         return final ;
         }		 
      
      printdata(NV, NE,vars,espar, numvar,param, s->x,fc, J, JD,ordentot);

      // print_state (iter, s,vars,numgslvar,NE);

      if (status)   /* check if solver is stuck */
        break;

      status = 
        gsl_multiroot_test_residual (s->f, 1e-7);
    }
  while (status == GSL_CONTINUE && *itera < 10);

 
  printf ("RES status = %s -%d\n", gsl_strerror (status),status);
  if (status!=0){
    printf( "MAL ITERA: %d - %d \n",status, *itera);
    //final[0]=-3.1415;//HORRIBLE CAMBIAR
    *success=-1;
    return final ;
  }
  
  print_state (*itera, s,vars,numgslvar,numgslpar,NE,NP,param,ordentot);
  
  calcdata(NV, NE, espar,numvar,param,s->x,fc,J,JD,p,NFM,NCM,NVF,matrizred,lrtra,orieqreten,ordentot,dp,NVM);
  printdata(NV, NE,vars,espar, numvar,param, s->x,fc, J, JD,ordentot);
  
  //double final[NV];
  
  for (int i=0; i<NV; i++){
    double rr=0;
    if (espar[i]){
      rr=gsl_vector_get (param, numvar[i]);
      printf("gsl par %d, es var %d, vale %f, %s \n",numvar[i],i,rr,vars[ordentot[i]]);
    }else{
      rr=gsl_vector_get (s->x, numvar[i]);
      printf("gsl var %d, es var %d, vale %f, %s \n",numvar[i],i,rr,vars[ordentot[i]]);
    }
    final[i]=rr;
  }
      /*  for (int i=NV-NP; i<NV; i++){
       gsl_vector_set (param, i-(NV-NP), inicial[i]);
       }*/


  gsl_multiroot_fsolver_free (s);
  gsl_vector_free (x);


  return final;
}



        	//printf("gsl var %d, es var %d, vale %f \n",numvar[i],i,gsl_vector_get (s->x, numvar[i]));
        	/*	if ((numvar[j]==18 or numvar[j]==3) and i==20){
	    printf("PPPUNTO x %d, vale %f \n",18,gsl_vector_get (x,18));
             printf("PPPUNTO x %d, vale %f \n",3,gsl_vector_get (x,3));
             printf("PPPUNTO es ecua %d, vale %f \n",20,gsl_vector_get (fd,20));
              double yyy=evaluate(20);
             printf("PPPUNTO  vale %f \n",yyy);
         	}*/

 /*  printf("PPPUNTO x %d, vale %f \n",18,gsl_vector_get (x,18));
    printf("PPPUNTO x %d, vale %f \n",3,gsl_vector_get (x,3));
    printf("PPPUNTO es ecua %d, vale %f \n",20,gsl_vector_get (fc,20));
   */  
   //for (int i=0; i<NE; i++){
   //printf("PUNTO es ecua %d, vale %f \n",i,gsl_vector_get (fc,i));
     // }
